## firebuild 0.8.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

project(Firebuild C CXX)

include(CMakeOptions.txt)

if (NOT DEFINED FIREBUILD_VERSION)
  # Set in tagged commits only
  set(FIREBUILD_VERSION "0.8.5")
endif()

if (NOT DEFINED FIREBUILD_VERSION)
  execute_process(COMMAND git describe OUTPUT_VARIABLE FIREBUILD_VERSION OUTPUT_STRIP_TRAILING_WHITESPACE)
  set(FIREBUILD_VERSION "Git ${FIREBUILD_VERSION}")
endif()

include(CheckIPOSupported)
check_ipo_supported(RESULT IPO_SUPPORTED OUTPUT IPO_SUPPORT_ERROR)
if(NOT IPO_SUPPORTED)
  message(STATUS "IPO / LTO not supported: <${IPO_SUPPORT_ERROR}>")
endif()

include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
include(GNUInstallDirs)

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)
# TODO set to install dir
set(DATADIR "${CMAKE_INSTALL_FULL_DATAROOTDIR}/firebuild" CACHE STRING "Firebuild's architecture-independent files' location")
set(TENTATIVE_C_CXX_FLAGS
  -std=c++20
  -W
  -Wall
  -Wextra
  -Werror
  -Wpointer-arith
  -Warray-bounds
  -Wcast-align
  -Wformat -Wformat-security
  -fstrict-overflow -Wstrict-overflow=4
  -Wunreachable-code
  -Warray-bounds
  -fvisibility=hidden
  -Woverflow
#  -Wlogical-op clang does not like that
  -Wredundant-decls
  -Wno-format-zero-length)

foreach(FLAG ${TENTATIVE_C_CXX_FLAGS})
  string(MAKE_C_IDENTIFIER "C_FLAG_VALID_${FLAG}" V)
  check_c_compiler_flag("${FLAG}" ${V})
  if (${V})
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${FLAG}")
  endif()
  string(MAKE_C_IDENTIFIER "CXX_FLAG_VALID_${FLAG}" V_CXX)
  check_cxx_compiler_flag(${FLAG} ${V_CXX})
  if (${V_CXX})
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAG}")
  endif()
endforeach()

if (NOT APPLE)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Weffc++")
else()
  # Those warnings are raised when assigning values where 32 bits
  # are way more than enough.
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-shorten-64-to-32")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-shorten-64-to-32")
endif()

# dynamic library handling
if (APPLE)
  set(LD_PRELOAD "DYLD_INSERT_LIBRARIES")
  set(LIBFIREBUILD_SO "libfirebuild.dylib")
else()
  set(LD_PRELOAD "LD_PRELOAD")
  set(LIBFIREBUILD_SO "libfirebuild.so")
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")

if (APPLE)
  # build the interceptor for multiple architectures
  set(FAT_ARCH_C_FLAGS "-arch arm64 -arch arm64e -arch x86_64")
  set(CMAKE_SHARED_LINKER_FLAGS ${FAT_ARCH_C_FLAGS})
  # TODO build the supervisor, too, for multiple architectures
endif()

if(COVERAGE)
  # minimal (lines) coverage
  set(MIN_COVERAGE "65")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fprofile-arcs -ftest-coverage")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fprofile-arcs -ftest-coverage")
endif(COVERAGE)

if (SANITIZE)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=undefined")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=undefined")
endif()

if (ENABLE_XXH_INLINE_ALL)
  add_definitions(-DXXH_INLINE_ALL)
endif()
string(TOUPPER "${CMAKE_BUILD_TYPE}" uppercase_CMAKE_BUILD_TYPE)
if (uppercase_CMAKE_BUILD_TYPE STREQUAL "DEBUG")
  add_definitions(-DFB_EXTRA_DEBUG)
endif()

add_subdirectory(src)

enable_testing()
add_subdirectory(test)
add_subdirectory(man)

# add a target to generate API documentation with Doxygen
find_package(Doxygen)
if(DOXYGEN_FOUND)
  configure_file(${CMAKE_SOURCE_DIR}/Doxyfile.in ${CMAKE_BINARY_DIR}/Doxyfile @ONLY)
  add_custom_target(doc
    ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMENT "Generating API documentation with Doxygen" VERBATIM)
endif(DOXYGEN_FOUND)

if(COVERAGE)
  add_custom_target(coverage-info
    tools/calculate-coverage
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMENT "Generating coverage report with lcov" VERBATIM)
endif(COVERAGE)

add_custom_target(style-check
  cpplint --quiet --recursive ${CMAKE_SOURCE_DIR}/src/ ${CMAKE_SOURCE_DIR}/test/)

configure_file("${CMAKE_SOURCE_DIR}/etc/firebuild.conf" "${CMAKE_BINARY_DIR}/etc/firebuild.conf" COPYONLY)

install(FILES "${CMAKE_BINARY_DIR}/etc/firebuild.conf" DESTINATION "${CMAKE_INSTALL_SYSCONFDIR}")
if (APPLE)
  install(FILES "${CMAKE_SOURCE_DIR}/etc/bash_completion.d/firebuild" DESTINATION "${CMAKE_INSTALL_SYSCONFDIR}/bash_completion.d")
else()
  install(FILES "${CMAKE_SOURCE_DIR}/etc/bash_completion.d/firebuild" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/bash-completion/completions")
endif()
install(FILES data/build-report.html DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/firebuild")
install(FILES data/firebuild-logo.svg DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/firebuild")

=== man/CMakeLists.txt ===
find_program(XSLTPROC xsltproc)
if(XSLTPROC)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/firebuild.1.xml.in ${CMAKE_CURRENT_BINARY_DIR}/firebuild.1.xml @ONLY)
  add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/man1/firebuild.1"
    COMMAND ${XSLTPROC} --nonet --param "man.authors.section.enabled" "0" --param "man.output.in.separate.dir" "1" http://docbook.sourceforge.net/release/xsl/current/manpages/profile-docbook.xsl ${CMAKE_CURRENT_BINARY_DIR}/firebuild.1.xml
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/firebuild.1.xml
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMENT "Generating man pages with xsltproc" VERBATIM)
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/man1/firebuild.1" DESTINATION "${CMAKE_INSTALL_MANDIR}/man1")
  add_custom_target(man DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/man1/firebuild.1)
  add_dependencies(firebuild man)
endif(XSLTPROC)

=== src/CMakeLists.txt ===
include_directories("${CMAKE_CURRENT_SOURCE_DIR}")
include_directories("${CMAKE_CURRENT_BINARY_DIR}")

set_source_files_properties(common/debug_sysflags.c PROPERTIES COMPILE_FLAGS "-fPIC ${FAT_ARCH_C_FLAGS}")
set_source_files_properties(common/contrib/heapsort.c common/firebuild_common.c PROPERTIES COMPILE_FLAGS "-fPIC ${FAT_ARCH_C_FLAGS}")
set_source_files_properties(fbbcomm.c PROPERTIES COMPILE_FLAGS "-fPIC ${FAT_ARCH_C_FLAGS}")

add_custom_command(
  OUTPUT fbbcomm.c fbbcomm.cc fbbcomm.h fbbcomm_decode.c
  DEPENDS common/fbbcomm.def
  common/fbb/generate_fbb
  common/fbb/tpl.c
  common/fbb/tpl.h
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/common
  COMMAND ./fbb/generate_fbb fbbcomm ${CMAKE_CURRENT_BINARY_DIR}
  COMMENT "Generating fbbcomm files")

add_custom_target(fbbcomm_gen_files ALL DEPENDS fbbcomm.c fbbcomm.cc fbbcomm.h fbbcomm_decode.c)

set(COMMON_OBJS_SOURCES common/firebuild_common.c common/debug_sysflags.c)
#if(APPLE)
  set(COMMON_OBJS_SOURCES common/contrib/heapsort.c ${COMMON_OBJS_SOURCES})
#endif()
add_library(common_objs OBJECT ${COMMON_OBJS_SOURCES})
add_library(fbbcomm_c OBJECT fbbcomm.c)
add_dependencies(fbbcomm_c fbbcomm_gen_files)
add_library(fbbcomm_cc OBJECT fbbcomm.cc)
add_dependencies(fbbcomm_cc fbbcomm_gen_files)

add_subdirectory(interceptor)
add_subdirectory(firebuild)

execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpmachine
                OUTPUT_VARIABLE C_COMPILER_TARGET_ARCH
                OUTPUT_STRIP_TRAILING_WHITESPACE)
string(REGEX REPLACE "-.*" "" C_COMPILER_TARGET_ARCH ${C_COMPILER_TARGET_ARCH})
configure_file(${CMAKE_SOURCE_DIR}/src/common/config.h.in ${CMAKE_BINARY_DIR}/src/common/config.h @ONLY)

=== test/CMakeLists.txt ===
add_custom_command(
  OUTPUT fbbtest.cc fbbtest.h fbbtest_decode.c
  DEPENDS fbbtest.def
  ../src/common/fbb/generate_fbb
  ../src/common/fbb/tpl.c
  ../src/common/fbb/tpl.h
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ../src/common/fbb/generate_fbb fbbtest ${CMAKE_CURRENT_BINARY_DIR}
  COMMENT "Generating fbbtest files")

add_custom_target(fbbtest_gen_files ALL DEPENDS fbbtest.cc fbbtest.h fbbtest_decode.c)
add_custom_target(check-bins)

function(add_test_binary TEST_BINARY)
  add_executable("${TEST_BINARY}" EXCLUDE_FROM_ALL "${TEST_BINARY}.c")
  add_dependencies(check-bins "${TEST_BINARY}")
endfunction()

foreach(TESTFILE empty-config.conf integration.bats print_tbd_lib_arch_exports test_parallel_make.Makefile test_symbols)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/${TESTFILE}" "${CMAKE_CURRENT_BINARY_DIR}/${TESTFILE}" COPYONLY)
endforeach()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/test_helper.bash.in ${CMAKE_CURRENT_BINARY_DIR}/test_helper.bash @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/run-firebuild.in ${CMAKE_CURRENT_BINARY_DIR}/run-firebuild)

add_test(bats-integration env LC_ALL=C ./integration.bats)
# firebuild's debug build would crash on the invalid entries in an assert()
if (uppercase_CMAKE_BUILD_TYPE STREQUAL "DEBUG" OR CMAKE_C_FLAGS MATCHES "-DFB_EXTRA_DEBUG")
  set_property(TEST bats-integration PROPERTY ENVIRONMENT "SKIP_GC_INVALID_ENTRIES_TEST=1")
endif()
add_custom_target(check ctest -V)
add_custom_target(valgrind-check env FIREBUILD_PREFIX_CMD='${CMAKE_CURRENT_BINARY_DIR}/close_fds_exec valgrind -q --leak-check=full --track-fds=yes --error-exitcode=1' ctest -V)

add_test_binary(test_cmd_fork_exec)
add_test_binary(test_cmd_popen)
add_test_binary(test_cmd_posix_spawn)
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
add_test_binary(test_cmd_clone)
endif()
add_test_binary(test_cmd_system)
add_test_binary(test_pthreads)
target_link_libraries(test_pthreads "-lpthread")
add_test_binary(test_system)
add_test_binary(test_exec)
if (SANITIZE)
  set_source_files_properties(test_file_ops.c PROPERTIES COMPILE_DEFINITIONS "SKIP_TEST_NULL_NONNULL_PARAMS=1")
endif()
add_test_binary(test_file_ops)
if(APPLE)
  set_source_files_properties(test_file_ops.c PROPERTIES COMPILE_FLAGS "-Wno-deprecated-declarations")
endif()
target_link_libraries(test_file_ops "-ldl")
add_library(test_dlopen_lib SHARED
  EXCLUDE_FROM_ALL
  test_dlopen_lib.c)
add_dependencies(check-bins test_dlopen_lib)
add_test_binary(test_file_ops_2)
add_test_binary(test_file_ops_3)
add_test_binary(test_random)
set_source_files_properties(test_sendfile.c PROPERTIES COMPILE_FLAGS "-Wno-deprecated-declarations")
add_test_binary(test_sendfile)
add_test_binary(test_wait)
add_test_binary(test_orphan)
add_test_binary(close_fds_exec)
add_test_binary(test_err)
if(NOT APPLE)
  add_test_binary(test_error)
endif()
add_test_binary(test_env_fixup)

if(NOT APPLE)
add_test_binary(test_static)
target_link_libraries(test_static "-static")
endif()

include_directories(${CMAKE_SOURCE_DIR}/src ${CMAKE_BINARY_DIR}/src ${CMAKE_CURRENT_BINARY_DIR})
file(CREATE_LINK ${CMAKE_SOURCE_DIR}/data "${CMAKE_BINARY_DIR}/test/data" SYMBOLIC)
set_source_files_properties(fbb_test.cc PROPERTIES COMPILE_FLAGS "-Wno-cast-align")
add_executable(fbb_test EXCLUDE_FROM_ALL fbb_test.cc fbbtest.cc)
add_dependencies(fbb_test fbbtest_gen_files)
add_test(fbb ./fbb_test)
add_custom_target(check-deps)
add_dependencies(check-deps fbb_test)
add_dependencies(check-deps firebuild)
add_dependencies(check-deps firebuild-bin)
add_dependencies(check check-deps check-bins)
add_dependencies(valgrind-check check-deps check-bins close_fds_exec)

if(APPLE)
  add_test(test-symbols env CMAKE_OSX_SYSROOT=${CMAKE_OSX_SYSROOT} ./test_symbols ${CMAKE_BINARY_DIR})
else()
  add_test(test-symbols ./test_symbols ${CMAKE_BINARY_DIR})
endif()

=== src/firebuild/CMakeLists.txt ===

# GCC raises warning about the GCC-optimized code
set_source_files_properties(debug.cc execed_process.cc file_name.cc obj_cache.cc utils.cc PROPERTIES COMPILE_FLAGS "-Wno-strict-overflow")

# FBB structures and placing them aligned in buffers ensure that members will be aligned properly, too
set_source_files_properties(execed_process_cacher.cc PROPERTIES COMPILE_FLAGS "-Wno-cast-align -Wno-strict-overflow")
set_source_files_properties(message_processor.cc PROPERTIES COMPILE_FLAGS "-Wno-cast-align")

find_package(LibConfig REQUIRED)
find_package(PkgConfig REQUIRED)
# xxh128's algorithm changed and became officially supported in 0.8.0
pkg_check_modules(XXHASH REQUIRED libxxhash>=0.8.0)
if (WITH_JEMALLOC)
  pkg_check_modules(JEMALLOC jemalloc)
endif()
find_package(tsl-hopscotch-map REQUIRED)
if (APPLE)
  pkg_check_modules(PLIST REQUIRED libplist-2.0>=2.3.0)
  find_library(IOKit IOKit)
  find_library(CoreFoundation CoreFoundation)
else()
  pkg_check_modules(libelf REQUIRED libelf)
endif()
if (SANITIZE)
  if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    # older GCCs needs the -static-libasan parameter to avoid ASan complaining with fakeroot
    set(SANITIZE_SUPERVISOR_LINK_OPTIONS -static-libasan -fsanitize=address -fsanitize=undefined)
  else()
    set(SANITIZE_SUPERVISOR_LINK_OPTIONS -fsanitize=address -fsanitize=undefined)
  endif()
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -I${tsl-hopscotch-map_INCLUDE_DIRS}")
set_source_files_properties(config.cc PROPERTIES INCLUDE_DIRECTORIES "${LIBCONFIGPP_INCLUDE_DIR}")

add_custom_command(
  OUTPUT fbbfp.cc fbbfp.h fbbfp_decode.c
  DEPENDS fbbfp.def
  ../common/fbb/generate_fbb
  ../common/fbb/tpl.c
  ../common/fbb/tpl.h
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ../common/fbb/generate_fbb fbbfp ${CMAKE_CURRENT_BINARY_DIR}
  COMMENT "Generating fbbfp files")

add_custom_target(fbbfp_gen_files ALL DEPENDS fbbfp.cc fbbfp.h fbbfp_decode.c)

add_custom_command(
  OUTPUT fbbstore.cc fbbstore.h fbbstore_decode.c
  DEPENDS fbbstore.def
  ../common/fbb/generate_fbb
  ../common/fbb/tpl.c
  ../common/fbb/tpl.h
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ../common/fbb/generate_fbb fbbstore ${CMAKE_CURRENT_BINARY_DIR}
  COMMENT "Generating fbbstore files")

add_custom_target(fbbstore_gen_files ALL DEPENDS fbbstore.cc fbbstore.h fbbstore_decode.c)

add_executable(firebuild-bin
  base64.cc
  command_rewriter.cc
  config.cc
  debug.cc
  epoll.cc
  file_name.cc
  firebuild.cc
  pipe.cc
  pipe_recorder.cc
  process.cc
  exe_matcher.cc
  execed_process.cc
  execed_process_cacher.cc
  execed_process_env.cc
  forked_process.cc
  message_processor.cc
  options.cc
  process_factory.cc
  process_tree.cc
  hash.cc
  hash_cache.cc
  file_fd.cc
  file_info.cc
  file_usage.cc
  file_usage_update.cc
  blob_cache.cc
  obj_cache.cc
  report.cc
  sigchild_callback.cc
  utils.cc
  fbbfp.cc
  fbbstore.cc
  $<TARGET_OBJECTS:common_objs>
  $<TARGET_OBJECTS:fbbcomm_cc>)
target_link_libraries(firebuild-bin ${LIBCONFIGPP_LIBRARY} ${JEMALLOC_LDFLAGS} ${XXHASH_LDFLAGS} ${libelf_LIBRARIES} ${PLIST_LINK_LIBRARIES} ${IOKit} ${CoreFoundation})
target_link_options(firebuild-bin PUBLIC -Wno-array-bounds -Wno-strict-overflow ${SANITIZE_SUPERVISOR_LINK_OPTIONS})
set_target_properties(firebuild-bin PROPERTIES OUTPUT_NAME firebuild)
# GCC 9's LTO implementation seem to have a bug we hit, but did not fully triage yet
# https://github.com/Tessil/hopscotch-map/issues/55
if ((NOT uppercase_CMAKE_BUILD_TYPE STREQUAL "DEBUG")
    AND NOT (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 10))
  set_target_properties(firebuild-bin PROPERTIES INTERPROCEDURAL_OPTIMIZATION True)
endif()

add_dependencies(firebuild-bin fbbcomm_gen_files fbbfp_gen_files fbbstore_gen_files)

install(TARGETS firebuild-bin DESTINATION bin)

=== src/interceptor/CMakeLists.txt ===
include_directories("${CMAKE_CURRENT_BINARY_DIR}")

# gnu89 required to avoid the __isoc99_scanf hell
# ignored warnings most likely don't exist in every compiler version
set_source_files_properties(interceptors.c PROPERTIES COMPILE_FLAGS "-std=gnu89 -Wno-pragmas -Wno-unknown-warning-option -Wno-deprecated-declarations ${FAT_ARCH_C_FLAGS}")

# the trace markers may truncate the marker messages
set_source_files_properties(intercept.c
  PROPERTIES COMPILE_FLAGS "-Wno-unknown-warning-option -Wno-stringop-truncation -DFIREBUILD_VERSION='\"${FIREBUILD_VERSION}\"' ${FAT_ARCH_C_FLAGS}")

if (SANITIZE)
  set(SANITIZE_INTERCEPTOR_LINK_OPTIONS -fsanitize=undefined)
endif()

add_custom_command (
  OUTPUT gen_decl.h gen_def.c gen_impl.c gen_impl_syscalls.c.inc gen_list.txt gen_reset.c
  DEPENDS generate_interceptors
  tpl.c.jinja2
  tpl_clone.c.jinja2
  tpl_closefrom.c.jinja2
  tpl_copy_file_range.c.jinja2
  tpl_close_range.c.jinja2
  tpl_dlopen.c.jinja2
  tpl_dup2.c.jinja2
  tpl_error.c.jinja2
  tpl_exec.c.jinja2
  tpl__exit.c.jinja2
  tpl_exit.c.jinja2
  tpl_fcntl.c.jinja2
  tpl_fork.c.jinja2
  tpl__fork.c.jinja2
  tpl_ioctl.c.jinja2
  tpl_marker_only.c.jinja2
  tpl_once.c.jinja2
  tpl_open.c.jinja2
  tpl_pclose.c.jinja2
  tpl_pipe.c.jinja2
  tpl_popen.c.jinja2
  tpl_posix_spawn.c.jinja2
  tpl_posix_spawn_file_actions.c.jinja2
  tpl_pthread_create.c.jinja2
  tpl_read.c.jinja2
  tpl_readlink.c.jinja2
  tpl_recvmsg.c.jinja2
  tpl_seek.c.jinja2
  tpl_shm_open.c.jinja2
  tpl_signal.c.jinja2
  tpl_skip.c.jinja2
  tpl_syscall.c.jinja2
  tpl_system.c.jinja2
  tpl_write.c.jinja2
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ./generate_interceptors ${CMAKE_CURRENT_BINARY_DIR}
  COMMENT "Generating interceptor files from templates")

add_custom_target(gen_files ALL DEPENDS gen_decl.h gen_def.c gen_impl.c gen_impl_syscalls.c.inc gen_list.txt gen_reset.c)

set_source_files_properties(
  env.c
  ic_file_ops.c
  PROPERTIES COMPILE_FLAGS "${FAT_ARCH_C_FLAGS}")

add_library(firebuild SHARED
  env.c
  ic_file_ops.c
  intercept.c
  interceptors.c
  $<TARGET_OBJECTS:common_objs>
  $<TARGET_OBJECTS:fbbcomm_c>)

add_dependencies(firebuild gen_files fbbcomm_gen_files)

set_target_properties(firebuild PROPERTIES VERSION "0.0.0" SOVERSION 0)
if (NOT uppercase_CMAKE_BUILD_TYPE STREQUAL "DEBUG")
  set_target_properties(firebuild PROPERTIES INTERPROCEDURAL_OPTIMIZATION True)
endif()
target_link_libraries(firebuild dl)

target_link_options(firebuild PUBLIC -Wno-strict-overflow ${SANITIZE_INTERCEPTOR_LINK_OPTIONS})

install(TARGETS firebuild DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== debian/changelog ===
firebuild (0.8.5-1) unstable; urgency=medium

  * New upstream release
    - Fix flaky clone() test (Closes: #1115384)
  * debian: Fix bash rebuild autopkgtest.
    The ./configure and make flags should be identical to the packaged bash build
    to use distro-specific settings. (LP: #2120853)
  * Drop backported patches
  * Suggest the out-of-archive qemu-user-interposable package
  * debian/control: Depend on libelf-dev

 -- Balint Reczey <balint@balintreczey.hu>  Sun, 16 Nov 2025 21:27:44 +0100

=== debian/control ===
Source: firebuild
Section: non-free/devel
Priority: optional
Maintainer: Balint Reczey <balint@balintreczey.hu>
Build-Depends: bats,
               bc,
               clang,
               cmake (>= 3.13),
               debhelper-compat (= 12),
               docbook-xsl,
               fakeroot <!nocheck>,
               gcc (>= 4:10) | gcc-10,
               g++ (>= 4:10) | g++-10,
               libconfig++-dev,
               libelf-dev,
               libjemalloc-dev,
               libtsl-hopscotch-map-dev,
               libxxhash-dev (>= 0.8),
               moreutils,
               po-debconf,
               python3-jinja2,
               xsltproc
Standards-Version: 4.7.2
Homepage: https://firebuild.com
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/firebuild
Vcs-Git: https://salsa.debian.org/debian/firebuild.git -b debian/master
XS-Autobuild: yes

Package: firebuild
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${glibc:Depends},
         libfirebuild0 (= ${binary:Version})
Pre-Depends: debconf | debconf-2.0
# needs patched qemu-user package
Suggests: node-d3,
          qemu-user-interposable
Description: Automatic build accelerator cache
 It works by caching the outputs of executed commands and replaying the
 results when the same commands are executed with the same parameters
 within the same environment.
 .
 The commands can be compilation or other build artifact generation
 steps, tests, or any command that produces predictable output. The
 commands to cache and replay from the cache are determined
 automatically based on firebuild's configuration and each command's
 and its children's observed behavior.
 .
 Firebuild supports caching compilation results of C, C++, Fortran, Java,
 Rust, Scala and other compilers and outputs of scripts written in Bash,
 Perl, Python and other interpreted languages.

Package: libfirebuild0
Section: non-free/libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${glibc:Depends}
Pre-Depends: debconf | debconf-2.0
Description: Automatic build accelerator cache - shared library
 It works by caching the outputs of executed commands and replaying the
 results when the same commands are executed with the same parameters
 within the same environment.
 .
 The commands can be compilation or other build artifact generation
 steps, tests, or any command that produces predictable output. The
 commands to cache and replay from the cache are determined
 automatically based on firebuild's configuration and each command's
 and its children's observed behavior.
 .
 Firebuild supports caching compilation results of C, C++, Fortran, Java,
 Rust, Scala and other compilers and outputs of scripts written in Bash,
 Perl, Python and other interpreted languages.
 .
 This package provides the shared library preloaded by the intercepted
 processes.

=== debian/tests/control ===
Tests: build-time-tests-with-installed-firebuild
Depends: @builddeps@
Restrictions: needs-root, allow-stderr

Tests: recompile-bash
Depends: bash, bc, debconf, time
Restrictions: needs-root, allow-stderr

## firebuild 0.8.5.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 if (NOT DEFINED FIREBUILD_VERSION)
   # Set in tagged commits only
-  set(FIREBUILD_VERSION "0.8.5")
+  set(FIREBUILD_VERSION "0.8.5.1")
 endif()
 
 if (NOT DEFINED FIREBUILD_VERSION)

=== debian/changelog ===
firebuild (0.8.5.1-1) unstable; urgency=medium

  * debian/changelog: Rewrote too long line
  * New upstream release

 -- Balint Reczey <balint@balintreczey.hu>  Wed, 19 Nov 2025 22:07:34 +0100

## firebuild 0.8.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 if (NOT DEFINED FIREBUILD_VERSION)
   # Set in tagged commits only
-  set(FIREBUILD_VERSION "0.8.5.1")
+  set(FIREBUILD_VERSION "0.8.6")
 endif()
 
 if (NOT DEFINED FIREBUILD_VERSION)

=== debian/changelog ===
firebuild (0.8.6-1) unstable; urgency=medium

  * New upstream release
    - Support zstd cache compression
  * Build-depend on libzstd-dev

 -- Balint Reczey <balint@balintreczey.hu>  Tue, 10 Feb 2026 12:45:28 +0100

=== debian/control ===
--- 
+++ 
@@ -16,6 +16,7 @@
                libjemalloc-dev,
                libtsl-hopscotch-map-dev,
                libxxhash-dev (>= 0.8),
+               libzstd-dev,
                moreutils,
                po-debconf,
                python3-jinja2,

## firebuild 0.8.6.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 if (NOT DEFINED FIREBUILD_VERSION)
   # Set in tagged commits only
-  set(FIREBUILD_VERSION "0.8.6")
+  set(FIREBUILD_VERSION "0.8.6.1")
 endif()
 
 if (NOT DEFINED FIREBUILD_VERSION)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -73,6 +73,11 @@
 target_link_libraries(test_static "-static")
 endif()
 
+# mtime syscall test
+add_test_binary(test_mtime)
+# stat family test
+add_test_binary(test_stat)
+
 include_directories(${CMAKE_SOURCE_DIR}/src ${CMAKE_BINARY_DIR}/src ${CMAKE_CURRENT_BINARY_DIR})
 file(CREATE_LINK ${CMAKE_SOURCE_DIR}/data "${CMAKE_BINARY_DIR}/test/data" SYMBOLIC)
 set_source_files_properties(fbb_test.cc PROPERTIES COMPILE_FLAGS "-Wno-cast-align")

=== src/firebuild/CMakeLists.txt ===
--- 
+++ 
@@ -10,6 +10,7 @@
 find_package(PkgConfig REQUIRED)
 # xxh128's algorithm changed and became officially supported in 0.8.0
 pkg_check_modules(XXHASH REQUIRED libxxhash>=0.8.0)
+pkg_check_modules(ZSTD REQUIRED libzstd)
 if (WITH_JEMALLOC)
   pkg_check_modules(JEMALLOC jemalloc)
 endif()
@@ -92,7 +93,7 @@
   fbbstore.cc
   $<TARGET_OBJECTS:common_objs>
   $<TARGET_OBJECTS:fbbcomm_cc>)
-target_link_libraries(firebuild-bin ${LIBCONFIGPP_LIBRARY} ${JEMALLOC_LDFLAGS} ${XXHASH_LDFLAGS} ${libelf_LIBRARIES} ${PLIST_LINK_LIBRARIES} ${IOKit} ${CoreFoundation})
+target_link_libraries(firebuild-bin ${LIBCONFIGPP_LIBRARY} ${JEMALLOC_LDFLAGS} ${XXHASH_LDFLAGS} ${ZSTD_LDFLAGS} ${libelf_LIBRARIES} ${PLIST_LINK_LIBRARIES} ${IOKit} ${CoreFoundation})
 target_link_options(firebuild-bin PUBLIC -Wno-array-bounds -Wno-strict-overflow ${SANITIZE_SUPERVISOR_LINK_OPTIONS})
 set_target_properties(firebuild-bin PROPERTIES OUTPUT_NAME firebuild)
 # GCC 9's LTO implementation seem to have a bug we hit, but did not fully triage yet

=== src/interceptor/CMakeLists.txt ===
--- 
+++ 
@@ -58,6 +58,7 @@
 set_source_files_properties(
   env.c
   ic_file_ops.c
+  time64_cast.c
   PROPERTIES COMPILE_FLAGS "${FAT_ARCH_C_FLAGS}")
 
 add_library(firebuild SHARED
@@ -65,6 +66,7 @@
   ic_file_ops.c
   intercept.c
   interceptors.c
+  time64_cast.c
   $<TARGET_OBJECTS:common_objs>
   $<TARGET_OBJECTS:fbbcomm_c>)

=== debian/changelog ===
firebuild (0.8.6.1-1) unstable; urgency=medium

  * New upstream bugfix release
    - supervisor: Clear cache when it is in an old format
    - supervisor: Don't run GC in no-fetch or no-store modes.
      Also don't update cache metadata in read-only mode.

 -- Balint Reczey <balint@balintreczey.hu>  Sun, 01 Mar 2026 23:30:11 +0100
